"""Throws a NotImplementedError exception.

Calling ffi.verify will raise an exception  at cffi/verifiery.py:171 with the
following messager:

    NotImplementedError: <int(*)(void const * , void const * )>

This function appears to be preparing C function arguments. It handles
primitive types, pointers and structures, but raises an exception for all other
types. Aparently this includes function pointers.
"""
from cffi import FFI

ffi = FFI()
ffi.cdef("""
void qsort(void *base, size_t nel, size_t width,
        int (*compar)(const void *, const void *));
""")
ffi.verify("#include <stdlib.h>")
