import cffi

ffi = cffi.FFI()
xffi = cffi.FFI()

x_h = open("/usr/include/X11/X.h").read()
xlib_h = open("/usr/include/X11/Xlib.h").read()
    
x_h_lines = x_h.splitlines()
xlib_h_lines = xlib_h.splitlines()

# lines that should be replaced so cffi can parse it
x_h_delte = list(range(52)) + list(range(78, 94)) + list(range(715, 176))
xlib_h_delete = list(range(35)) + list(range(61, 67)) + \
                list(range(74, 77)) + list(range(102 , 155)) + \
                list(range(4025, 4032))

def prepare_source(source, lines_to_delete):
    
    #delete all lines that are not parseble by cffi
    for i in sorted(lines_to_delete, reverse=True):
        del source[i]
        
    for i in range(len(source)):
        if source[i].startswith("#define"):
            tmp = source[i].split()
            if len(tmp) <= 2:
                tmp = ""
            else:
                tmp[2] = "..."
            source[i] = " ".join(tmp)
        elif source[i].startswith("#"):
            source[i] = ""



prepare_source(x_h_lines, x_h_delte)
prepare_source(xlib_h_lines, xlib_h_delete)

x_h = "\n".join(x_h_lines)
xlib_h = "\n".join(xlib_h_lines)

# easier to look at as a fiel than on terminal
#open("tmp", "w").write(xlib_h)

# here is the actual error
xffi.cdef(x_h + "\n" + xlib_h)

# very simple test case
xffi.cdef("""
          #define Bool ...
          
          Bool is_active();
          """)