from __future__ import (print_function, division, absolute_import)

import os
import re
import traceback

__all__ = [
]

################################################################################

from cffi import FFI, CDefError
_ffi = FFI()

_ffi.cdef("""
struct SDL_Renderer;
typedef struct SDL_Renderer SDL_Renderer;

typedef enum SDL_bool_enum
{
    SDL_FALSE = 0,
    SDL_TRUE = 1
} SDL_bool;

SDL_bool SDL_RenderTargetSupported(SDL_Renderer *renderer);
""")
    
_SDL = _ffi.verify("""
#include <SDL2/SDL.h>
""", libraries=['SDL2'])

################################################################################

for name,value in _SDL.__dict__.items():
    if not name.startswith('SDL_'):
        continue
    __all__.append(name)
    globals()[name] = value
    print(name)

################################################################################
