from cffi import FFI
ffi = FFI()

ffi.set_source("_example",
    """ 
        #include <stdio.h>

        struct CStruct;
        void _add_callback ( struct CStruct * (* ptr) (int) );
    """,
    runtime_library_dirs=['.'],
    libraries=['mylib'])

ffi.cdef('''

    void _add_callback ( struct CStruct * (* ptr) (int) );

''')

@ffi.callback("struct CStruct * (int)")
def set_struct(x):
    return 0

if __name__ == "__main__":
    ffi.compile()

    from _example import ffi, lib

    lib._add_callback(ffi.cast("void * ", set_struct)) # this works
    lib._add_callback(set_struct) # this doesn't work

