# note: assuming a GNU/Linux with gcc installed

#compile the library
import os
os.system("gcc -shared mytest.c -o libmytest.so")

from cffi import FFI
ffi = FFI()

ffi.cdef(
"""
	typedef enum etest2 etest2;
	typedef int etest3;

	enum test4 {
		TEST4_MINUS_HUNDRED = -100
	};

	int test1(void);
	etest2 test2(void);
	etest3 test3(void);
""")

# https://bitbucket.org/cffi/cffi/issues/219
cffi_test = ffi.dlopen("./libmytest.so")

test1 = cffi_test.test1()
test2 = cffi_test.test2()
test3 = cffi_test.test3()
test4 = cffi_test.TEST4_MINUS_HUNDRED

print("test1", test1, type(test1))
print("test2", test2, type(test2))
print("test3", test3, type(test3))
print("test4", test4, type(test4))

