#!/usr/bin/python3

import unittest
import cffi
import importlib
import pycparser
import subprocess

def preprocess(source):
    return subprocess.run(['gcc', '-E', '-P', '-'],
            input=source, stdout=subprocess.PIPE,
            universal_newlines=True, check=True).stdout

def load(filename):
    print('Loading ' + filename)
    source = open(filename + '.c').read()
    includes = preprocess(open(filename + '.h').read())
    
    ffibuilder = cffi.FFI()
    ffibuilder.cdef(includes)
    print('21')
    ffibuilder.set_source(filename + '_', source)
    ffibuilder.compile()

    module = importlib.import_module(filename + '_')
    return module.lib

class StringUtilsTest(unittest.TestCase):
    def test_cmp(self):
        module = load('stringutils')
        self.assertTrue(module.cmp('howdy', 'howdy'))
        self.assertFalse(module.cmp('howdy', 'haudy'))

#run(StringUtilsTest)
if __name__ == '__main__':
    unittest.main()
