
from cffi import FFI

ffi = FFI()

src = '''
struct inner {
    long one;
    long two;
};

struct outer {
    struct inner one;
    struct inner two;
};
'''
ffi.cdef(src)

lib = ffi.verify(src)

def test():
    outer = ffi.new('struct outer *')
    outer.one.one = 5
    inner = outer.one
    del outer
    # Force some allocations to overwrite the freed memory.
    things = [ffi.new('struct outer *') for i in xrange(64)]
    assert inner.one == 5

