# file "example_build.py"
from cffi import FFI
ffi = FFI()
ffi.cdef("typedef struct mytest {	int table[100000000]; } mytest_t;")
ffi.set_source("_example",
"""
typedef struct mytest {	int table[100000000]; } mytest_t;
""")
if __name__ == "__main__":
	ffi.compile()

# file "example.py"
from _example import ffi, lib
mytest = ffi.new("mytest_t*")

# windows 10 - python 3.6 32 bits - CFFI 1.12.3 ERROR !! 
# ffi.error: struct mytest: wrong total size (cdef says 1, but C compiler says 400000000). 
# fix it or use "...;" in the cdef for struct mytest to make it flexible

# windows 10 - python 3.6 64 bits - CFFI 1.12.3 OK !! 
print('done')