from cffi import FFI

ffi = FFI()
ffi.cdef("""
typedef int AnIntegerWith32Bits;
typedef AnIntegerWith32Bits (*AFunctionReturningInteger) ();
AnIntegerWith32Bits InvokeFunction(AFunctionReturningInteger);
""")

lib = ffi.verify("""
#ifdef __LP64__
typedef int AnIntegerWith32Bits;
#else
typedef long AnIntegerWith32Bits;
#endif
typedef AnIntegerWith32Bits (*AFunctionReturningInteger) ();
AnIntegerWith32Bits InvokeFunction(AFunctionReturningInteger f) {
    return f();
}
""")

@ffi.callback("AFunctionReturningInteger")
def add():
    return 3 + 4

print(lib.InvokeFunction(add))
