from cffi import FFI
ffibuilder = FFI()

ffibuilder.set_source(
    "_foo",
    r"""
    #include <thread>
    #include <cstdlib>
    #include <unistd.h>

    struct T
    {
        ~T() {
            t.join();
        }

        std::thread t;
    };

    static T g_thread;

    typedef void(*foo_t)(void);
    static foo_t g_foo;

    void set_foo(foo_t new_foo) {
        g_foo = new_foo;
    }

    void call_foo(void) {
        g_thread.t = std::thread([] { g_foo(); sleep(3); });
        sleep(1);
    }
    """,
    libraries=[],
    source_extension=".cpp",
)


ffibuilder.cdef("""
extern "Python" void my_foo(void);
typedef void(*foo_t)(void);
void set_foo(foo_t new_foo);
void call_foo(void);
""")

if __name__ == "__main__":
    ffibuilder.compile(verbose=True)
